//+------------------------------------------------------------------+
//|                                     C12_UltimateRoundNumbers.mq4 |
//+------------------------------------------------------------------+
#property copyright   "https://www.forexfactory.com/c-12"
#property link        "https://www.forexfactory.com/c-12"
#property strict
#property indicator_chart_window
//---
input uint  GridStep=100;//Step, pips
extern string custom_grid=" type your custom grid pair separate by comma";

input string grid_1000_pairs="HKG33,JPN225,USDNOK,USDPLN,USDSEK,USDCNH,USDTRY";
input string grid_10000_pairs="BCHUSD,LTCUSD,DSHUSD,USDRUB";
input string grid_100000_pairs="ETHUSD";
input string grid_1000000_pairs="BTCUSD";

input string grid_500_pairs=".US30Cash,.USTECHCash,.DE30Cash,ESP35,WTI,BRENT";
input string grid_5000_pairs="XAUUSD,XRPUSD,USDCZK,USDMXN,USDZAR";
input string grid_50000_pairs="USDHUF";
input string grid_500000_pairs="";

input color LineColor=clrGreen;//Color
input ENUM_LINE_STYLE LineStyle=STYLE_SOLID;//Style
input int LineWidth=2;
input string LineText="RoundNr_1";//Prefixzzzz
//---

string G1000[];
string G10000[];
string G100000[];
string G1000000[];

string G500[];
string G5000[];
string G50000[];
string G500000[];



int OnInit()
{//Alert("indicator expired at 18 feb 2020");
 //if(TimeCurrent()>D'2020.02.18'){Alert("indi expired");ObjectsDeleteAll(); ExpertRemove();return(INIT_FAILED);}
 return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   
 //if(TimeCurrent()>D'2020.02.18'){Alert("indi expired");ObjectsDeleteAll(); ExpertRemove();return(INIT_FAILED);}

   if(prev_calculated==0)
     {
      double Highest=High[ArrayMaximum(High)];
      double Lowest=Low[ArrayMinimum(Low)];

      int coef_point=(_Digits==1 || _Digits==3 || _Digits==5)?10:1;
      
     uint GS=GridStep; 
    ushort u_sep=StringGetCharacter(",",0); 


    StringSplit(grid_1000_pairs,u_sep,G1000);
    int tot=ArraySize(G1000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G1000[x])>=0)GS=1000;
    
    }
    
    StringSplit(grid_10000_pairs,u_sep,G10000);
     tot=ArraySize(G10000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G10000[x])>=0)GS=10000;    
    }
    
    StringSplit(grid_100000_pairs,u_sep,G100000);
     tot=ArraySize(G100000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G100000[x])>=0)GS=100000;    
    }
    
    StringSplit(grid_1000000_pairs,u_sep,G1000000);
     tot=ArraySize(G1000000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G1000000[x])>=0)GS=1000000;    
    }


    StringSplit(grid_500_pairs,u_sep,G500);
     tot=ArraySize(G500);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G500[x])>=0)GS=500;    
    }

    StringSplit(grid_5000_pairs,u_sep,G5000);
     tot=ArraySize(G5000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G5000[x])>=0)GS=5000;    
    }

    StringSplit(grid_50000_pairs,u_sep,G50000);
     tot=ArraySize(G50000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G50000[x])>=0)GS=50000;    
    }    
    
    StringSplit(grid_500000_pairs,u_sep,G500000);
     tot=ArraySize(G500000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G500000[x])>=0)GS=500000;    
    }

      
      double Step=fmax(1,GS)*_Point*coef_point;

      double Max=round(1.1*Highest/Step)*Step;
      double Min=round(0.8*Lowest/Step)*Step;

      //Print(Max," ",Min," ",Step);

      for(double i=Min; i<=Max; i+=Step)
        {
         string obj_name=LineText+"_"+DoubleToString(i,_Digits);

         if(ObjectFind(0,obj_name)==0 || 
            ObjectCreate(0,obj_name,OBJ_HLINE,0,0,i))
           {
            ObjectSetInteger(0,obj_name,OBJPROP_STYLE,LineStyle);
            ObjectSetInteger(0,obj_name,OBJPROP_COLOR,LineColor);
            ObjectSetInteger(0,obj_name,OBJPROP_WIDTH,LineWidth);
            ObjectSetInteger(0,obj_name,OBJPROP_SELECTABLE,False);
            ObjectSetDouble(0,obj_name,OBJPROP_PRICE,i);
           }
        }

      ChartRedraw();
     }
//---
   return(rates_total);
  }
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   ObjectsDeleteAll(0,LineText,0,-1);
   ChartRedraw();
  }
//+------------------------------------------------------------------+
